/**
 * Created by 弘树<tiehang.lth@alibaba-inc.com> on 15/4/21.
 */
var assert = require('assert');
var clamUtil = require('../../lib/index');
var shell = require('shelljs');

describe('test util methods', function () {

  this.timeout(100000);

  it.skip('test compareSemver', function () {

    assert.equal(clamUtil.compareSemver('0.1.2', '0.1.22'), -1);
    assert.equal(clamUtil.compareSemver('0.1.2', '1.0.2'), -1);
    assert.equal(clamUtil.compareSemver('0.1.2', '0.1.2'), 0);
    assert.equal(clamUtil.compareSemver('0.1.2', '0.1.3.5'), -1);
    assert.equal(clamUtil.compareSemver('0.1.2', '0.1.1'), 1);
    assert.equal(clamUtil.compareSemver('1.2', '0.9.99'), 1);

  });

  it.skip('test calcTopNVersions', function () {

    var arr = ['1.2.3', '1.3.4', '0.1.1', '0.1.2', '0.2.3', '0.3.2'];
    assert.equal(clamUtil.calcTopNVersions(arr, 2).join(), '1.3.4,1.2.3');
    assert.equal(clamUtil.calcTopNVersions(arr, 3).join(), '1.3.4,1.2.3,0.3.2');
    assert.equal(clamUtil.calcTopNVersions(arr, 4).join(), '1.3.4,1.2.3,0.3.2,0.2.3');
    assert.equal(clamUtil.calcTopNVersions(arr, 5).join(), '1.3.4,1.2.3,0.3.2,0.2.3,0.1.2');

  });

  it.skip('test wait until url available', function (done) {

    var url = 'http://wapp.waptest.taobao.com/trip/test-clam-hs.html';
    clamUtil.waitUntilUrlAvailable(url, function (ret) {
      assert.equal(ret, true, '检查 url 资源存在');
      done();
    });

  });

  it('test git diff', function (done) {

    shell.cd('/Users/hongshu/AliDrive/dev/gitlab/pigeon-platform/repo/h5-op2op');

    var ret = clamUtil.calcDiffFiles('publish/2015.0706.110618', 'publish/2015.0706.133639', 'build_offline_trip');
    console.log(ret);
    done();

  });

  it('test stablizeObject', function () {
    assert.equal(JSON.stringify(clamUtil.stablizeObject({
      b: {
        d: 10,
        c: 'm'
      },
      a: 12,
      def: {
        q: 1,
        x: 2,
        ms: 4,
        z: {
          s: 't',
          h: 3,
          wu: 1,
          sa: 'j'
        }
      }
    })), '{"a":12,"b":{"c":"m","d":10},"def":{"ms":4,"q":1,"x":2,"z":{"h":3,"s":"t","sa":"j","wu":1}}}');
  });

  it('test parseDepMap', function () {

  });

});